package com.iformall.controller.market;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.ErrorCode;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.WxOrder;
import com.iformall.domain.po.WxPayOrder;
import com.iformall.enums.EnumPayStatus;
import com.iformall.exception.MallinkException;
import com.iformall.service.WxOrderService;
import com.iformall.service.WxPayOrderService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@RestController
@RequestMapping("wxPayOrder")
@Api(description = "支付订单接口")
public class WxPayOrderController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxOrderService wxOrderService;

    @Autowired
    private WxPayOrderService wxPayOrderService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "支付订单-列表")
    public ResultData list(@ModelAttribute WxPayOrder wxPayOrder, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxPayOrderController::list");
        if (null == wxPayOrder) wxPayOrder = new WxPayOrder();
        final PageInfo<WxPayOrder> page = wxPayOrderService.listAsPage(wxPayOrder, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "支付订单-新增")
    public ResultData add(@RequestBody WxPayOrder wxPayOrder) {
        logger.debug("[" + getIpAddr() + "] WxPayOrderController::add");
        //Assert.notNull(wxPayOrder.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxPayOrderService.saveOrUpdate(wxPayOrder);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "支付订单-更新")
    public ResultData update(@RequestBody WxPayOrder wxPayOrder) {
        logger.debug("[" + getIpAddr() + "] WxPayOrderController::update");
        wxPayOrderService.saveOrUpdate(wxPayOrder);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "支付订单-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxPayOrderController::delete");
        wxPayOrderService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "支付订单-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxPayOrderController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxPayOrderService.getById(id));
    }

    @ApiOperation(value = "更新支付订单状态", notes = "{\"payOrderId\":\"string\",\"orderId\":\"string\",\"status\":integer,\"reason\":\"string\"}")
    @PostMapping("/updatePayOrder")
    @SystemControllerLog(description = "支付订单-更新支付订单状态")
    public ResultData updatePayOrder(@RequestBody Map<String, Object> paramMap) {
        logger.info("/api/pay/updatePayOrder" + paramMap.toString());
        String payOrderIdStr = (String) paramMap.get("payOrderId");
        String orderIdStr = (String) paramMap.get("orderId");
        String reasonStr = (String) paramMap.get("reason");
        Integer status = (Integer) paramMap.get("status");
        if (StringUtils.isBlank(orderIdStr)) {
            logger.info("orderId不能为空: " + paramMap.toString());
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL.getCode(), "orderId不能为空");
        }
        try {
            Long.valueOf(orderIdStr);
        } catch (NumberFormatException e) {
            logger.error("orderId参数不正确: " + paramMap.toString() + ", e:" + e.getMessage());
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL.getCode(), "orderId参数不正确");
        }
        if (!StringUtils.isBlank(payOrderIdStr)) {
            try {
                Long.valueOf(payOrderIdStr);
            } catch (NumberFormatException e) {
                logger.error("payOrderId参数不正确: " + paramMap.toString() + ", e:" + e.getMessage());
                return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL.getCode(), "payOrderId参数不正确");
            }
        }
        // 免费券直接返回成功
        return new ResultData(Result.SUCCESS, "免费券支付状态更新成功");

    }
}
